local shockwave = {}

local keyPressed = false
local force = 60
function shockwave.unload()
end
function shockwave.init()
end

function applyForce(playerCoord, entity)
	local coord=ENTITY.GET_ENTITY_COORDS(entity,true)
	local dx=coord.x - playerCoord.x
	local dy=coord.y - playerCoord.y
	local dz=coord.z - playerCoord.z
	local distance=math.sqrt(dx*dx+dy*dy+dz*dz)
	local distanceRate=(force/distance)*math.pow(1.04,1-distance)
	ENTITY.APPLY_FORCE_TO_ENTITY(entity, true, distanceRate*dx,distanceRate*dy,distanceRate*dz, math.random()*math.random(-1,1),math.random()*math.random(-1,1),math.random()*math.random(-1,1), true, false, true, true, true, true)
end

function shockwave.tick()
	if (get_key_pressed(Keys.Add)) then
		keyPressed = true
	elseif keyPressed then
		keyPressed = false
		local player = PLAYER.PLAYER_PED_ID()
		local playerCoord=ENTITY.GET_ENTITY_COORDS(player,true)		
		
		local Table,Count = PED.GET_PED_NEARBY_VEHICLES(player, 1)
		local playerVehicle = PLAYER.GET_PLAYERS_LAST_VEHICLE()
		local inVehicle=PED.IS_PED_IN_VEHICLE(player,playerVehicle,true)
		for k,v in ipairs(Table) do
			if(not inVehicle or playerVehicle ~= v) then
				-- ENTITY.SET_ENTITY_CAN_BE_DAMAGED(v,true)
				-- VEHICLE.DISABLE_VEHICLE_IMPACT_EXPLOSION_ACTIVATION(v,true)
				applyForce(playerCoord, v)
			end
		end

		Table,Count = PED.GET_PED_NEARBY_PEDS(player, 1,1)
		for k,v in ipairs(Table) do
			PED.SET_PED_RAGDOLL_ON_COLLISION(v,true)
			PED.SET_PED_RAGDOLL_FORCE_FALL(v)
			applyForce(playerCoord, v)
		end
	end
end

return shockwave